public abstract class Quadrilatero
{
	private double[] lati = new double[4];

	public Quadrilatero(double l1, double l2, double l3, double l4)
	{
		lati[0] = l1;
		lati[1] = l2;
		lati[2] = l3;
		lati[3] = l4;
	}

	public double getLato(int i)
	{
		return lati[i];
	}

	protected double setLato(int i, double val)
	{
		System.out.println("Cambio il valore del lato " + i);
		double retval = lati[i];
		lati[i] = val;
		return retval;
	}

	public double perimetro()
	{
		System.out.println("perimetro secondo il quadrilatero");
		int i = 0;
		double retval = 0;
		for(i=0;i<4;i++)
		{
			retval += lati[i];
		}
		return retval;
	}

	public abstract double area();

	public String toString()
	{
		return "io sono un quadrilatero con lati " + lati[0] + ", " + lati[1] + ", " + lati[2] + ", " + lati[3];
	}

	public static void main(String[] argv)
	{
		if(argv.length > 0)
		{
			System.out.println("Gioco con i quadrati");
			Quadrato.main(argv);
		}
		else
		{
			System.out.println("non faccio nulla");
		}
	}

	static
	{
		System.out.println("Inizializzatore statico di Quadrialtero");
	}
}
