package it.unipd.is.collections;

import java.util.*;

public class TestSet
{
	public static void main(String[] argv)
	{
		(new TestSet()).exec(argv);
	}

	public void exec(String[] argv)
	{
		Set<MyStringHolder> s = new HashSet<MyStringHolder>();
		//Set<MyStringHolder> s = new TreeSet<MyStringHolder>();

		int i = 0;

		for(i=0;i<argv.length;i++)
		{
			s.add(new MyStringHolder(argv[i]));
		}
		System.out.println(s);
	}

	public class MyStringHolder
	implements Comparable
	{
		String val;

		public MyStringHolder(String s)
		{
			val = s;
		}

		public int compareTo(Object o)
		{
			//MyStringHolder tmp = (MyStringHolder)o;
			return this.val.compareTo(((MyStringHolder)o).val);
		}

		public boolean equals(Object o)
		{
			assert o instanceof MyStringHolder;

			if(! (o instanceof MyStringHolder))
			{
				return false;
			}

			return (this.compareTo(o) == 0);
		}

		public int hashCode()
		{
			return val.hashCode();
		}

		public String toString()
		{
			return val;
		}
	}
}
