package requestExecute;

public class Key
implements Comparable<Key>
{
	private static java.util.concurrent.atomic.AtomicInteger count;
	private int val;

	public Key()
	{
		val = count.getAndIncrement();
	}

	public String toString()
	{
		return String.valueOf(val);
	}

	public boolean equals(Object o)
	{
		assert o instanceof Key;

		if(!( o instanceof Key))
		{
			return false;
		}
		return ( (Key)o).val == val;
	}

	public int hashCode()
	{
		return val;
	}

	public int compareTo(Key k)
	{
		return val-k.val;
	}

	static
	{
		count = new java.util.concurrent.atomic.AtomicInteger(Integer.MIN_VALUE);
	}
}
