package rmi;

import java.rmi.*;
import net.*;

public class Client
implements Runnable
{
	Counter c;
	public Client(Counter counter)
	{
		c = counter;
	}

	public static void main(String[] argv)
	{
		Counter tmp = null;
		try
		{
			tmp = (Counter)Naming.lookup(argv[0]);
		}
		catch(RemoteException | NotBoundException | java.net.MalformedURLException re)
		{
			re.printStackTrace();
		}

		int k = 1;
		if(argv.length > 1)
		{
			k = Integer.parseInt(argv[1]);
		}

		for(int i = 0;i<k;i++)
		{
			(new Thread(new Client(tmp))).start();
		}
	}

	public void run()
	{
		try
		{
			IntHolder ih = new IntHolder();

			System.out.println(c.count());
			System.out.println(c.inc());
			System.out.println(c.add( 10 ));
			System.out.println(ih);
			IntHolder ih2 = c.add(ih, 5);
			System.out.println(ih + " " + ih2);
		}
		catch(RemoteException re)
		{
			re.printStackTrace();
		}
	}
}
